/*
 * nokia1616/1661 TFT lcd Driver for AVR microcontroller
 * Copyright (C) 2021 Electronic Girl
 * web site: https://sisoog.com
 *
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of  MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program.  If not, see <http://www.gnu.org/licenses/>.
 */
 
#include "STM8S.h"
#include "STM8S_lcd.h"
 
 
void clock_setup(void);
void GPIO_setup(void);
 
 
void main(void)
{
    int j;
		const char txt1[] = {"MICROARENA"}; 
    const char txt2[] = {"Sisoog"}; 
    const char txt3[] = {"STM8S003F"};
    const char txt4[] = {"Discovery"};
                                                                                     
    unsigned char s = 0x00;
                                                                                    
    clock_setup();
    GPIO_setup();
                                                                                     
    LCD_init();  
    LCD_clear_home(); 
 
    LCD_goto(0, 0);                              
    LCD_putstr(txt1); 
		for(j=0;j<32000;j++);
                                                                  
    //LCD_clear_home();
    LCD_goto(1, 1);
    LCD_putstr(txt2);
    for(j=0;j<32000;j++);
                                                                  
    LCD_clear_home();
                                                                
    for(s = 0; s < 9; s++)
    {
        LCD_goto((0 + s), 0);   
        LCD_putchar(txt3[s]);
         for(j=0;j<32000;j++);
    }
		//LCD_clear_home();
   for(s = 0; s < 9; s++)
   {
        LCD_goto((0 + s), 1);   
        LCD_putchar(txt4[s]);
         for(j=0;j<32000;j++);
    }
                                                                               
    while (TRUE);
}
 
 
void clock_setup(void)
{
    CLK_DeInit();
                                                                    
    CLK_HSECmd(DISABLE);
    CLK_LSICmd(DISABLE);
    CLK_HSICmd(ENABLE);
    while(CLK_GetFlagStatus(CLK_FLAG_HSIRDY) == FALSE);
                              
    CLK_ClockSwitchCmd(ENABLE);
    CLK_HSIPrescalerConfig(CLK_PRESCALER_HSIDIV8);
    CLK_SYSCLKConfig(CLK_PRESCALER_CPUDIV1);
                                         
    CLK_ClockSwitchConfig(CLK_SWITCHMODE_AUTO, CLK_SOURCE_HSI, 
    DISABLE, CLK_CURRENTCLOCKSTATE_ENABLE);
                                          
    CLK_PeripheralClockConfig(CLK_PERIPHERAL_SPI, DISABLE);
    CLK_PeripheralClockConfig(CLK_PERIPHERAL_I2C, DISABLE);
    CLK_PeripheralClockConfig(CLK_PERIPHERAL_ADC, DISABLE);
    CLK_PeripheralClockConfig(CLK_PERIPHERAL_AWU, DISABLE);
    CLK_PeripheralClockConfig(CLK_PERIPHERAL_UART1, DISABLE);
    CLK_PeripheralClockConfig(CLK_PERIPHERAL_TIMER1, DISABLE);
    CLK_PeripheralClockConfig(CLK_PERIPHERAL_TIMER2, DISABLE);
    CLK_PeripheralClockConfig(CLK_PERIPHERAL_TIMER4, DISABLE);
}
 
 
void GPIO_setup(void)
{
    GPIO_DeInit(LCD_PORT);
}